/* -*- Mode: C; tab-width: 4 -*- */
/* ex: set tabstop=4: */ 
	   
/* Panorama_Tools	-	Generate, Edit and Convert Panoramic Images
   Copyright (C) 1998,1999 - Helmut Dersch	der@fh-furtwangen.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*------------------------------------------------------------*/

#ifndef SYS_GTK_H
#define SYS_GTK_H

#include <gtk/gtk.h>

#include "filter.h"

#define ENTRY_WIDTH 30


struct wdata
{
	GtkWidget	*widg;
	gpointer	data;
};

typedef struct wdata wdata;

extern int ptools_isOK;

void pt_widget_destroy			(GtkWidget *widget);
void pt_main_destroy			(GtkWidget *widget);

void DispPrg		(GtkWidget *widget, gpointer data);
void SetLumOpt		(GtkWidget *widget, gpointer data);
void SetCPrefs		(GtkWidget *widget, gpointer data);
void SetRadOpt		(GtkWidget *widget, gpointer data);
void SetHorOpt		(GtkWidget *widget, gpointer data);
void SetVerOpt		(GtkWidget *widget, gpointer data);
void SetScOpt		(GtkWidget *widget, gpointer data);
void SetShOpt		(GtkWidget *widget, gpointer data);
void SetAdPrefs		(GtkWidget *widget, gpointer data);
void SetCrOpt		(GtkWidget *widget, gpointer data);
void SetPerspPrefs	(GtkWidget *widget, gpointer data);
void SetRem			(GtkWidget *widget, gpointer data);
void SetSiz			(GtkWidget *widget, gpointer data);
void SetIntp		(GtkWidget *widget, gpointer data);
void InfoPrg		(GtkWidget *widget, gpointer data);
void SetCutOpt		(GtkWidget *widget, gpointer data);
void SetPanOpt		(GtkWidget *widget, gpointer data);
void SetFrPrefs		(GtkWidget *widget, gpointer data);


void ptool_load_callback		(GtkWidget *widget, gpointer data);
void ptool_save_callback		(GtkWidget *widget, gpointer data);

void pt_set_size_source			(GtkWidget *widget, gpointer data);
void pt_load_corr				(GtkWidget *widget, gpointer data);
void pt_save_corr				(GtkWidget *widget, gpointer data);
void pt_set_file				(GtkWidget *widget, gpointer data);
void pt_find_file				(GtkWidget *widget, gpointer data);
void pt_help_connect			(GtkWidget *widget, const gchar *help_id);
void pt_help					(GtkWidget *widget, gpointer data);
void pt_standard_help_func		(const gchar *help_id, gpointer help_data);
void pt_rc_parse				(void);

#define		CheckButton( kRes, isChecked )												\
			gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (dp[kRes]), isChecked );	\
			isBool[kRes]  = ( (isChecked) ? 1 : 2 );

#define		SetText( kRes, string, var )												\
			sprintf( numString,	 string, var);											\
			gtk_entry_set_text(GTK_ENTRY(dp[kRes]), numString);

#define		SetLbl( kRes, string)														\
			gtk_label_set_text(GTK_LABEL(dp[kRes]), string);


#define		GetText( kRes, string, varaddr )											\
			sscanf( gtk_entry_get_text(GTK_ENTRY(dp[kRes])), string, varaddr);


#define MAKE_TABLE( hor, ver )															\
	table = gtk_table_new(hor, ver, FALSE);												\
	gtk_container_set_border_width(GTK_CONTAINER(table), 10);							\
	gtk_container_add(GTK_CONTAINER(frame), table);										\
	gtk_widget_show(table);

#define	 MAKE_TEXT_WID( kRes , left, right, top, bottom )								\
	dp[kRes] = gtk_entry_new( );														\
	gtk_widget_set_size_request( dp[kRes], ENTRY_WIDTH, -1);							\
	gtk_table_attach(GTK_TABLE(table), dp[kRes],left, right, top, bottom,				\
		GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);											\
	gtk_widget_show(dp[kRes]);

#define	 MAKE_FTEXT_WID( kRes , left, right, top, bottom )								\
	dp[kRes] = gtk_entry_new( );														\
	gtk_widget_set_size_request( dp[kRes], ENTRY_WIDTH, -1);							\
	gtk_table_attach(GTK_TABLE(ftable), dp[kRes],left, right, top, bottom,				\
		GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);											\
	gtk_widget_show(dp[kRes]);


#define	 MAKE_LABEL_WID( kRes , left, right, top, bottom )								\
	dp[kRes] = gtk_label_new("");														\
	gtk_table_attach(GTK_TABLE(table),dp[kRes],left, right, top, bottom,				\
		GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);											\
	gtk_widget_show(dp[kRes]);

#define	 MAKE_TEXTLABEL( text , table, left, right, top, bottom )						\
	label = gtk_label_new(text);														\
	gtk_table_attach(GTK_TABLE(table),label,left, right, top, bottom,					\
		GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);											\
	gtk_widget_show(label);


#define MAKE_CHECK_BOX( kRes, label, left, right, top, bottom )							\
	dp[kRes] = gtk_check_button_new_with_label ( label );								\
	gtk_table_attach(GTK_TABLE(table),dp[kRes],left, right, top, bottom,				\
		GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);											\
	gtk_widget_show(dp[kRes]);

#define MAKE_FCHECK_BOX( kRes, label, left, right, top, bottom )						\
	dp[kRes] = gtk_check_button_new_with_label ( label );								\
	gtk_table_attach(GTK_TABLE(ftable),dp[kRes],left, right, top, bottom,				\
		GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);											\
	gtk_widget_show(dp[kRes]);

#define MAKE_RADIO_BUTTON(	kRes, label )												\
   dp[kRes] = gtk_radio_button_new_with_label( group, label );							\
   gtk_box_pack_start (GTK_BOX (box), dp[kRes], TRUE, TRUE, 0);							\
   group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (dp[kRes]));					\
   gtk_widget_show (dp[kRes]);

#define INSERT_BUTTON(	left, right, top, bottom )										\
   gtk_table_attach(GTK_TABLE(table), button, left, right, top, bottom,					\
		GTK_FILL | GTK_EXPAND, GTK_FILL, 1, 1);

#define INSERT_FBUTTON(	 left, right, top, bottom )										\
   gtk_table_attach(GTK_TABLE(ftable), button, left, right, top, bottom,				\
		GTK_FILL | GTK_EXPAND, GTK_FILL, 1, 1);

#define INSERT_SEP( left, right, top, bottom )											\
   gtk_table_attach(GTK_TABLE(table), sep, left, right, top, bottom,					\
		GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);

#define MAKE_BFRAME(table, label, left, right, top, bottom, number)						\
	frame = gtk_frame_new(label);														\
	gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);					\
	gtk_container_set_border_width(GTK_CONTAINER(frame), 2);							\
	gtk_table_attach(GTK_TABLE(table), frame, left, right, top, bottom,					\
					 GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);							\
	box = gtk_vbox_new(FALSE, number);													\
	gtk_container_set_border_width(GTK_CONTAINER(box), 5);								\
	gtk_container_add(GTK_CONTAINER(frame), box);										\
	gtk_widget_show (box);																\
	gtk_widget_show (frame);															\
	group = NULL;

#define	  NUMRES	30


#define		GenCallBack( VarType,  DlgRes, Title, SetControl,SText,						\
						GText, DlgAction, WinFunc)										\
void WinFunc (GtkWidget *widget, gpointer data)											\
{																						\
	static GtkWidget		*dlg;														\
	GtkWidget				*table, *button, *frame, *box, *label, *sep;				\
	GSList					*group = NULL;												\
	static int				isBool[ NUMRES ];											\
	int i;																				\
	static GtkWidget*		dp[ NUMRES ];												\
	static VarType			localPrefs, *thePrefs;										\
	char numString[32];																	\
	static int isMain;																	\
																						\
	if( data != NULL )																	\
	{																					\
		isMain = ( widget == NULL );													\
		thePrefs = (VarType*)data;														\
		memcpy( &localPrefs, thePrefs, sizeof( VarType ));								\
		for(i=0; i<NUMRES; i++) isBool[i] = FALSE;										\
																						\
																						\
		dlg = gtk_dialog_new();															\
		gtk_window_set_title(GTK_WINDOW(dlg), Title);									\
		gtk_window_set_position(GTK_WINDOW(dlg), GTK_WIN_POS_CENTER_ON_PARENT);			\
		g_signal_connect_swapped(GTK_OBJECT(dlg), "destroy",							\
			(GtkSignalFunc) (isMain ? pt_main_destroy : pt_widget_destroy),				\
			GTK_OBJECT (dlg) );															\
																						\
		frame = gtk_frame_new(_("Settings"));											\
		gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);				\
		gtk_container_set_border_width(GTK_CONTAINER(frame), 10);						\
		gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg)->vbox), frame, TRUE, TRUE, 0);		\
																						\
		button = gtk_button_new_from_stock ("gtk-help");								\
		GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);									\
		g_signal_connect_swapped (GTK_OBJECT (button), "clicked",						\
						  (GtkSignalFunc) pt_help, dlg);								\
		gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dlg)->action_area),						\
				button, TRUE, TRUE, 0);													\
		gtk_button_box_set_child_secondary (GTK_BUTTON_BOX (GTK_DIALOG (dlg)->action_area),	   \
			   button, TRUE );															\
		gtk_widget_show (button);														\
																						\
		button = gtk_button_new_from_stock ("gtk-cancel");								\
		GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);									\
		g_signal_connect_swapped (GTK_OBJECT (button), "clicked",						\
		(GtkSignalFunc) (isMain ? pt_main_destroy : pt_widget_destroy),					\
							 GTK_OBJECT (dlg) );										\
		gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dlg)->action_area),						\
				button, TRUE, TRUE, 0);													\
		gtk_widget_show (button);														\
																						\
		button = gtk_button_new_from_stock ("gtk-ok");									\
		GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);									\
		g_signal_connect (GTK_OBJECT (button), "clicked",								\
					  (GtkSignalFunc) WinFunc,											\
					  NULL );															\
		gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dlg)->action_area),						\
				button, TRUE, TRUE, 0);													\
		gtk_widget_grab_default (button);												\
		gtk_widget_show (button);														\
		gtk_widget_show(frame);															\
																						\
		DlgRes																			\
		SText																			\
		SetControl																		\
																						\
		gtk_widget_show(dlg);															\
	}																					\
	else																				\
	{																					\
		GText																			\
																						\
		for(i=0; i < NUMRES; i++)														\
		{																				\
			if( isBool[i] == 1 )														\
			{																			\
				switch(i)																\
					DlgAction															\
			}																			\
		}																				\
		for(i=0; i < NUMRES; i++)														\
		{																				\
			if( isBool[i] && (GTK_TOGGLE_BUTTON (dp[i])->active) )						\
			{																			\
				switch(i)																\
					DlgAction															\
			}																			\
		}																				\
		memcpy( thePrefs, &localPrefs, sizeof( VarType) );								\
		ptools_isOK =TRUE;																\
		if(isMain)	gtk_main_quit();													\
		else		gtk_widget_destroy( dlg );											\
	}																					\


#define		GenDialog( VarType,	 DlgRes, Title, SetControl,SText,						\
						GText, DlgAction, WinFunc)										\
	gchar			**argv;																\
	gint			argc;																\
																						\
	argc			= 1;																\
	argv			= g_new(gchar *, 1);												\
	argv[0]			= g_strdup("dummy");												\
																						\
	gtk_init(&argc, &argv);																\
	pt_rc_parse();																		\
																						\
	WinFunc( NULL, (gpointer) thePrefs );												\
																						\
	gtk_main();																			\
	gdk_flush();																		\
	return ptools_isOK;																	\
}																						\
	GenCallBack( VarType,  DlgRes, Title, SetControl,SText,								\
						GText, DlgAction, WinFunc)


//-------------------------- Dialog Resources-----------------------------------------

//-------------------------- Dialogs for remap	-------------------------------------------

#define		kSetRemapPrefs_InRect				0
#define		kSetRemapPrefs_InPano				1
#define		kSetRemapPrefs_InErect				2
#define		kSetRemapPrefs_InSphereCenter		3
#define		kSetRemapPrefs_InSphereTop			4
#define		kSetRemapPrefs_OutRect				5
#define		kSetRemapPrefs_OutPano				6
#define		kSetRemapPrefs_OutErect				7
#define		kSetRemapPrefs_OutSphereCenter		8
#define		kSetRemapPrefs_OutSphereTop			9
#define		kSetRemapPrefs_Hfov					10
#define		kSetRemapPrefs_Vfov					11
#define		kSetRemapPrefs_InMirror				12
#define		kSetRemapPrefs_OutMirror			13
#define		kSetRemapPrefs_SetPrefs				14
#define		kSetRemapPrefs_dlg															\
	{																					\
	pt_help_connect(dlg, "panToolRemap");												\
	MAKE_TABLE(3, 4)																	\
																						\
	MAKE_TEXTLABEL(_("HFoV:"),			table, 0, 1, 2, 3);								\
	MAKE_TEXTLABEL(_("VFoV:"),			table, 2, 3, 2, 3);								\
	MAKE_BFRAME(table, _("From:"), 0, 2, 1, 2,	6);										\
	MAKE_RADIO_BUTTON( kSetRemapPrefs_InRect,		 _("Normal") )						\
	MAKE_RADIO_BUTTON( kSetRemapPrefs_InPano,		 _("QTVR") )						\
	MAKE_RADIO_BUTTON( kSetRemapPrefs_InErect,		 _("PSphere") )						\
	MAKE_RADIO_BUTTON( kSetRemapPrefs_InSphereTop,	 _("Fisheye hor.") )				\
	MAKE_RADIO_BUTTON( kSetRemapPrefs_InSphereCenter,_("Fisheye vert."))				\
	MAKE_RADIO_BUTTON( kSetRemapPrefs_InMirror,		 _("Convex mirror"))				\
																						\
	MAKE_BFRAME(table, _("To:"), 2, 4, 1, 2, 6);										\
	MAKE_RADIO_BUTTON( kSetRemapPrefs_OutRect,		  _("Normal") )						\
	MAKE_RADIO_BUTTON( kSetRemapPrefs_OutPano,		  _("QTVR") )						\
	MAKE_RADIO_BUTTON( kSetRemapPrefs_OutErect,		  _("PSphere") )					\
	MAKE_RADIO_BUTTON( kSetRemapPrefs_OutSphereTop,	  _("Fisheye hor.") )				\
	MAKE_RADIO_BUTTON( kSetRemapPrefs_OutSphereCenter,_("Fisheye vert."))				\
	MAKE_RADIO_BUTTON( kSetRemapPrefs_OutMirror,	  _("Convex mirror"))				\
																						\
	MAKE_TEXT_WID( kSetRemapPrefs_Hfov ,		1, 2, 2, 3 );							\
	MAKE_TEXT_WID( kSetRemapPrefs_Vfov ,		3, 4, 2, 3 );							\
	button = gtk_button_new_with_label (_("Preferences"));								\
	INSERT_BUTTON( 3, 4, 0, 1 );														\
	g_signal_connect (GTK_OBJECT (button), "clicked",									\
							 (GtkSignalFunc) SetSiz,									\
							 (gpointer) gsPrPtr);										\
	gtk_widget_show(button);															\
																						\
	}


//-------------------------- Dialogs for perspective  -------------------------------------------

#define		kSetPerspectivePrefs_InRect			0
#define		kSetPerspectivePrefs_InSphere		1
#define		kSetPerspectivePrefs_Degree			2
#define		kSetPerspectivePrefs_Points			3
#define		kSetPerspectivePrefs_Keep			4
#define		kSetPerspectivePrefs_X				5
#define		kSetPerspectivePrefs_Y				6
#define		kSetPerspectivePrefs_Gamma			7
#define		kSetPerspectivePrefs_Hfov			8
#define		kSetPerspectivePrefs_Width			9
#define		kSetPerspectivePrefs_Height			10
#define		kSetPerspectivePrefs_SetPrefs		11
#define		kSetPerspectivePrefs_dlg													\
	{																					\
	pt_help_connect(dlg, "panToolPerspective");											\
	MAKE_TABLE(6, 4)																	\
																						\
	MAKE_TEXTLABEL(_("Format:"),		table, 0, 1, 0, 1);								\
	MAKE_TEXTLABEL(_("Turn to:"),		table, 0, 1, 1, 2);								\
	MAKE_TEXTLABEL(_("Horizontal:"),	table, 1, 2, 1, 2);								\
	MAKE_TEXTLABEL(_("Vertical:"),	table, 1, 2, 2, 3);									\
	MAKE_TEXTLABEL(_("Rotate:"),		table, 0, 1, 3, 4);								\
	MAKE_TEXTLABEL(_("Size:"),		table, 0, 1, 4, 5);									\
	MAKE_TEXTLABEL(_("HFoV:"),		table, 2, 3, 3, 4);									\
	MAKE_TEXTLABEL(_("Width:"),			table, 2, 3, 4, 5);								\
	MAKE_TEXTLABEL(_("Height:"),		table, 2, 3, 5, 6);								\
																						\
	box = gtk_hbox_new(FALSE, 2);														\
	gtk_container_set_border_width(GTK_CONTAINER(box), 5);								\
	gtk_table_attach(GTK_TABLE(table), box, 1, 3, 0, 1,									\
		GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);											\
	gtk_widget_show (box);																\
	group = NULL;																		\
	MAKE_RADIO_BUTTON( kSetPerspectivePrefs_InSphere, _("Fisheye") )					\
	MAKE_RADIO_BUTTON( kSetPerspectivePrefs_InRect,	  _("Rectilinear") )				\
																						\
	MAKE_TEXT_WID( kSetPerspectivePrefs_X ,			2, 3, 1, 2 );						\
	MAKE_TEXT_WID( kSetPerspectivePrefs_Y ,			2, 3, 2, 3 );						\
	MAKE_TEXT_WID( kSetPerspectivePrefs_Gamma ,		1, 2, 3, 4 );						\
	MAKE_TEXT_WID( kSetPerspectivePrefs_Hfov ,		3, 4, 3, 4 );						\
	MAKE_TEXT_WID( kSetPerspectivePrefs_Width,		3, 4, 4, 5 );						\
	MAKE_TEXT_WID( kSetPerspectivePrefs_Height ,	3, 4, 5, 6 );						\
	box = gtk_vbox_new(FALSE, 2);														\
	gtk_container_set_border_width(GTK_CONTAINER(box), 5);								\
	gtk_table_attach(GTK_TABLE(table), box, 3, 4, 1, 3,									\
		GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);											\
	gtk_widget_show (box);																\
	group = NULL;																		\
	MAKE_RADIO_BUTTON( kSetPerspectivePrefs_Points, _("Pixels") )						\
	MAKE_RADIO_BUTTON( kSetPerspectivePrefs_Degree, _("Degrees") )						\
																						\
	button = gtk_button_new_with_label (_("Preferences"));								\
	INSERT_BUTTON( 3, 4, 0, 1 )															\
	g_signal_connect (GTK_OBJECT (button), "clicked",									\
							 (GtkSignalFunc) SetSiz,									\
							 (gpointer) gsPrPtr);										\
	gtk_widget_show(button);															\
																						\
	button = gtk_button_new_with_label (_("Source"));									\
	INSERT_BUTTON( 1, 2, 4, 5)															\
	g_signal_connect (GTK_OBJECT (button), "clicked",									\
							 (GtkSignalFunc) pt_set_size_source,						\
							 (gpointer) dp );											\
	gtk_widget_show(button);															\
	}

// ------------------------- Dialogs for correct ------------------------------------------------

#define		kSetCorrectPrefs_Save				0
#define		kSetCorrectPrefs_Load				1
#define		kSetCorrectPrefs_Radial				2
#define		kSetCorrectPrefs_RadialOption		3
#define		kSetCorrectPrefs_Horizontal			4
#define		kSetCorrectPrefs_HorizontalOption	5
#define		kSetCorrectPrefs_Vertical			6
#define		kSetCorrectPrefs_VerticalOption		7
#define		kSetCorrectPrefs_Shear				8
#define		kSetCorrectPrefs_ShearOption		9
#define		kSetCorrectPrefs_Scale				10
#define		kSetCorrectPrefs_ScaleOption		11
#define		kSetCorrectPrefs_Lum				12
#define		kSetCorrectPrefs_LumOpt				13
#define		kSetCorrectPrefs_SetPrefs			14
#define		kSetCorrectPrefs_CutFrame			15
#define		kSetCorrectPrefs_CutOpt				16
#define		kSetCorrectPrefs_Fourier			17
#define		kSetCorrectPrefs_FourierOpt			18
#define		kSetCorrectPrefs_dlg														\
	{																					\
	pt_help_connect(dlg, "panToolCorrect");												\
	MAKE_TABLE(11, 3);																	\
																						\
	MAKE_CHECK_BOX( kSetCorrectPrefs_Radial,	_("Radial"),			0, 1, 1, 2 )	\
	MAKE_CHECK_BOX( kSetCorrectPrefs_Vertical,	_("Vertical shift"),	0, 1, 2, 3 )	\
	MAKE_CHECK_BOX( kSetCorrectPrefs_Horizontal,_("Horizontal shift"),	0, 1, 3, 4 )	\
	MAKE_CHECK_BOX( kSetCorrectPrefs_Shear,		_("Shear"),				0, 1, 4, 5 )	\
	MAKE_CHECK_BOX( kSetCorrectPrefs_Scale,		_("Scale"),				0, 1, 5, 6 )	\
	MAKE_CHECK_BOX( kSetCorrectPrefs_Lum,		_("Radial luminance"),	0, 1, 6, 7 )	\
	MAKE_CHECK_BOX( kSetCorrectPrefs_CutFrame,	_("Cut frame"),			0, 1, 7, 8 )	\
	MAKE_CHECK_BOX( kSetCorrectPrefs_Fourier,	_("Fourier filter"),	0, 1, 8, 9 )	\
																						\
	button = gtk_button_new_with_label (_("Options"));									\
	INSERT_BUTTON( 1, 2, 1, 2)															\
	g_signal_connect (GTK_OBJECT (button), "clicked",									\
							 (GtkSignalFunc) SetRadOpt,									\
							 (gpointer) &localPrefs);									\
	gtk_widget_show(button);															\
																						\
	button = gtk_button_new_with_label (_("Options"));									\
	INSERT_BUTTON( 1, 2, 2, 3)															\
	g_signal_connect (GTK_OBJECT (button), "clicked",									\
							 (GtkSignalFunc) SetVerOpt,									\
							 (gpointer) &localPrefs);									\
	gtk_widget_show(button);															\
																						\
	button = gtk_button_new_with_label (_("Options"));									\
	INSERT_BUTTON( 1, 2, 3, 4)															\
	g_signal_connect (GTK_OBJECT (button), "clicked",									\
							 (GtkSignalFunc) SetHorOpt,									\
							 (gpointer) &localPrefs);									\
	gtk_widget_show(button);															\
																						\
	button = gtk_button_new_with_label (_("Options"));									\
	INSERT_BUTTON( 1, 2, 4, 5)															\
	g_signal_connect (GTK_OBJECT (button), "clicked",									\
							 (GtkSignalFunc) SetShOpt,									\
							 (gpointer) &localPrefs);									\
	gtk_widget_show(button);															\
																						\
	button = gtk_button_new_with_label (_("Options"));									\
	INSERT_BUTTON( 1, 2, 5, 6)															\
	g_signal_connect (GTK_OBJECT (button), "clicked",									\
							 (GtkSignalFunc) SetScOpt,									\
							 (gpointer) &localPrefs);									\
	gtk_widget_show(button);															\
																						\
	button = gtk_button_new_with_label (_("Options"));									\
	INSERT_BUTTON( 1, 2, 6, 7)															\
	g_signal_connect (GTK_OBJECT (button), "clicked",									\
							 (GtkSignalFunc) SetLumOpt,									\
							 (gpointer) &localPrefs);									\
	gtk_widget_show(button);															\
																						\
	button = gtk_button_new_with_label (_("Options"));									\
	INSERT_BUTTON( 1, 2, 7, 8)															\
	g_signal_connect (GTK_OBJECT (button), "clicked",									\
							 (GtkSignalFunc) SetCutOpt,									\
							 (gpointer) &localPrefs);									\
	gtk_widget_show(button);															\
																						\
	button = gtk_button_new_with_label (_("Options"));									\
	INSERT_BUTTON( 1, 2, 8, 9)															\
	g_signal_connect (GTK_OBJECT (button), "clicked",									\
							 (GtkSignalFunc) SetFrPrefs,								\
							 (gpointer) &localPrefs);									\
	gtk_widget_show(button);															\
																						\
																						\
	button = gtk_button_new_with_label (_("Preferences"));								\
	INSERT_BUTTON( 1, 3, 0, 1)															\
	g_signal_connect (GTK_OBJECT (button), "clicked",									\
							 (GtkSignalFunc) SetSiz,									\
							 (gpointer) gsPrPtr);										\
	gtk_widget_show(button);															\
	sep = gtk_hseparator_new();															\
	INSERT_SEP(0,3,9,10);																\
	gtk_widget_show(sep);																\
	button = gtk_button_new_with_label (_("Load"));										\
	INSERT_BUTTON( 1, 2, 10, 11)														\
	g_signal_connect (GTK_OBJECT (button), "clicked",									\
							 (GtkSignalFunc) ptool_load_callback,						\
							 (gpointer) &localPrefs );									\
	gtk_widget_show (button);															\
	button = gtk_button_new_with_label (_("Save"));										\
	INSERT_BUTTON( 2, 3, 10, 11)														\
	g_signal_connect (GTK_OBJECT (button), "clicked",									\
							 (GtkSignalFunc) ptool_save_callback,						\
							 (gpointer) &localPrefs );									\
	gtk_widget_show (button);															\
	}


#define		kSetLumOptions_Red					0
#define		kSetLumOptions_Green				1
#define		kSetLumOptions_Blue					2
#define		kSetLumOptions_dlg												\
	{																		\
	pt_help_connect(dlg, "corRadLum");										\
	MAKE_TABLE(3, 2);														\
																			\
	MAKE_TEXTLABEL(_("Red:"),			table, 0, 1, 0, 1);					\
	MAKE_TEXTLABEL(_("Green:"),			table, 0, 1, 1, 2);					\
	MAKE_TEXTLABEL(_("Blue:"),			table, 0, 1, 2, 3);					\
																			\
																			\
	MAKE_TEXT_WID( kSetLumOptions_Red ,			1, 2, 0, 1 );				\
	MAKE_TEXT_WID( kSetLumOptions_Green ,		1, 2, 1, 2 );				\
	MAKE_TEXT_WID( kSetLumOptions_Blue ,		1, 2, 2, 3 );				\
	}

#define		kSetRadialOptions_Slit				0
#define		kSetRadialOptions_Red0				1
#define		kSetRadialOptions_Red1				2
#define		kSetRadialOptions_Red2				3
#define		kSetRadialOptions_Red3				4
#define		kSetRadialOptions_Green0			5
#define		kSetRadialOptions_Green1			6
#define		kSetRadialOptions_Green2			7
#define		kSetRadialOptions_Green3			8
#define		kSetRadialOptions_Blue0				9
#define		kSetRadialOptions_Blue1				10
#define		kSetRadialOptions_Blue2				11
#define		kSetRadialOptions_Blue3				12
#define		kSetRadialOptions_radial			13
#define		kSetRadialOptions_horizontal		14
#define		kSetRadialOptions_vertical			15
#define		kSetRadialOptions_dlg										\
	{																	\
	pt_help_connect(dlg, "corRadial");									\
	MAKE_TABLE(6, 5);													\
																		\
	MAKE_TEXTLABEL(_("Red:"),		table, 0, 1, 1, 2);					\
	MAKE_TEXTLABEL(_("Green:"),		table, 0, 1, 2, 3);					\
	MAKE_TEXTLABEL(_("Blue:"),		table, 0, 1, 3, 4);					\
	MAKE_TEXTLABEL("a * r^4 +",		table, 1, 2, 0, 1);					\
	MAKE_TEXTLABEL("b * r^3 +",		table, 2, 3, 0, 1);					\
	MAKE_TEXTLABEL("c * r^2 +",		table, 3, 4, 0, 1);					\
	MAKE_TEXTLABEL("d * r",			table, 4, 5, 0, 1);					\
																		\
																		\
	MAKE_TEXT_WID( kSetRadialOptions_Red0 ,		4, 5, 1, 2 );			\
	MAKE_TEXT_WID( kSetRadialOptions_Red1 ,		3, 4, 1, 2 );			\
	MAKE_TEXT_WID( kSetRadialOptions_Red2 ,		2, 3, 1, 2 );			\
	MAKE_TEXT_WID( kSetRadialOptions_Red3 ,		1, 2, 1, 2 );			\
	MAKE_TEXT_WID( kSetRadialOptions_Green0 ,	4, 5, 2, 3 );			\
	MAKE_TEXT_WID( kSetRadialOptions_Green1 ,	3, 4, 2, 3 );			\
	MAKE_TEXT_WID( kSetRadialOptions_Green2 ,	2, 3, 2, 3 );			\
	MAKE_TEXT_WID( kSetRadialOptions_Green3 ,	1, 2, 2, 3 );			\
	MAKE_TEXT_WID( kSetRadialOptions_Blue0 ,	4, 5, 3, 4 );			\
	MAKE_TEXT_WID( kSetRadialOptions_Blue1 ,	3, 4, 3, 4 );			\
	MAKE_TEXT_WID( kSetRadialOptions_Blue2 ,	2, 3, 3, 4 );			\
	MAKE_TEXT_WID( kSetRadialOptions_Blue3 ,	1, 2, 3, 4 );			\
																		\
	MAKE_BFRAME(table, _("Correction mode:"), 0, 4, 4, 5, 3);			\
	MAKE_RADIO_BUTTON( kSetRadialOptions_radial,	 _("Radial") )		\
	MAKE_RADIO_BUTTON( kSetRadialOptions_horizontal, _("Horizontal") )	\
	MAKE_RADIO_BUTTON( kSetRadialOptions_vertical,	 _("Vertical") )	\
	}


#define		kSetHorizontalOptions_Red			 0
#define		kSetHorizontalOptions_Green			 1
#define		kSetHorizontalOptions_Blue			 2
#define		kSetLumOptions_RedText				 3
#define		kSetLumOptions_GreenText			 4
#define		kSetLumOptions_BlueText				 5
#define		kSetHorizontalOptions_dlg									\
	{																	\
	pt_help_connect(dlg, "corVertHorShift");							\
	MAKE_TABLE(3, 2);													\
																		\
	MAKE_LABEL_WID( kSetLumOptions_RedText ,   0, 1, 0, 1);				\
	MAKE_LABEL_WID( kSetLumOptions_GreenText , 0, 1, 1, 2);				\
	MAKE_LABEL_WID( kSetLumOptions_BlueText	 , 0, 1, 2, 3);				\
																		\
	MAKE_TEXT_WID( kSetHorizontalOptions_Red ,		1, 2, 0, 1 );		\
	MAKE_TEXT_WID( kSetHorizontalOptions_Green	 ,	1, 2, 1, 2 );		\
	MAKE_TEXT_WID( kSetHorizontalOptions_Blue,		1, 2, 2, 3 );		\
	}


#define		kSetShearOptions_vname				 0
#define		kSetShearOptions_vvar				 1
#define		kSetShearOptions_hname				 2
#define		kSetShearOptions_hvar				 3
#define		kSetShearOptions_dlg										\
	{																	\
	pt_help_connect(dlg, "corShear");									\
	MAKE_TABLE(2, 2);													\
																		\
	MAKE_LABEL_WID( kSetShearOptions_vname , 0, 1, 0, 1);				\
	MAKE_LABEL_WID( kSetShearOptions_hname , 0, 1, 1, 2);				\
																		\
	MAKE_TEXT_WID( kSetShearOptions_vvar ,	 1, 2, 0, 1 );				\
	MAKE_TEXT_WID( kSetShearOptions_hvar ,	 1, 2, 1, 2 );				\
	}

//-------------------  Dialogs for Adjust --------------------------


#define		kSetAdjustPrefs_Insert				0
#define		kSetAdjustPrefs_Extract				1
#define		kSetAdjustPrefs_SetCtrlPts			2
#define		kSetAdjustPrefs_RunOptimizer		3
#define		kSetAdjustPrefs_Options				4
#define		kSetAdjustPrefs_Script				5
#define		kSetAdjustPrefs_FindScript			6
#define		kSetAdjustPrefs_SetOpt				7
#define		kSetAdjustPrefs_SetPrefs			8
#define		kSetAdjustPrefs_dlg											\
	{																	\
	pt_help_connect(dlg, "panToolAdjust");								\
	MAKE_TABLE(2, 2);													\
																		\
	MAKE_BFRAME(table, _("Action:"), 0, 1, 1, 2, 5);					\
	MAKE_RADIO_BUTTON( kSetAdjustPrefs_Insert,		 _("Insert into panorama") )		\
	MAKE_RADIO_BUTTON( kSetAdjustPrefs_Extract,		 _("Extract from panorama") )		\
	MAKE_RADIO_BUTTON( kSetAdjustPrefs_SetCtrlPts,	 _("Read marked controlpoints") )	\
	MAKE_RADIO_BUTTON( kSetAdjustPrefs_RunOptimizer, _("Run position optimizer") )		\
																		\
	frame = gtk_frame_new(_("Parameters:"));							\
	gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);	\
		gtk_container_set_border_width(GTK_CONTAINER(frame), 2);		\
	gtk_table_attach(GTK_TABLE(table), frame, 1, 2, 1, 2,				\
		GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);							\
	gtk_widget_show (frame);											\
	{																	\
		GtkWidget				*ftable;								\
		ftable = gtk_table_new(2, 2, FALSE);							\
		gtk_container_set_border_width(GTK_CONTAINER(ftable), 2);		\
		gtk_container_add(GTK_CONTAINER(frame), ftable);				\
		gtk_widget_show(ftable);										\
		box = gtk_vbox_new(FALSE, 2);									\
		gtk_container_set_border_width(GTK_CONTAINER(box), 2);			\
		gtk_table_attach(GTK_TABLE(ftable), box, 0, 1, 0, 2,			\
			GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);						\
		gtk_widget_show (box);											\
		group = NULL;													\
		MAKE_RADIO_BUTTON( kSetAdjustPrefs_Options,		_("Use options"))	\
		MAKE_RADIO_BUTTON( kSetAdjustPrefs_Script,		_("Use script") )	\
																		\
																		\
		button = gtk_button_new_with_label (_("Set"));					\
		INSERT_FBUTTON( 1, 2, 0, 1)										\
		g_signal_connect (GTK_OBJECT (button), "clicked",				\
							 (GtkSignalFunc) SetCrOpt,					\
							 (gpointer) &localPrefs );					\
		gtk_widget_show(button);										\
																		\
		button = gtk_button_new_with_label (_("Browse"));				\
		INSERT_FBUTTON( 1, 2, 1, 2)										\
		g_signal_connect (GTK_OBJECT (button), "clicked",				\
							 (GtkSignalFunc) pt_find_file,				\
							 (gpointer) &(localPrefs.scriptFile) );		\
		gtk_widget_show(button);										\
	}																	\
	button = gtk_button_new_with_label (_("Preferences"));				\
	INSERT_BUTTON( 1, 2, 0, 1)											\
	g_signal_connect (GTK_OBJECT (button), "clicked",					\
							(GtkSignalFunc) SetSiz,						\
							(gpointer) gsPrPtr);						\
	gtk_widget_show(button);											\
	}


#define		kSetCreateOptions_ImR				0
#define		kSetCreateOptions_ImP				1
#define		kSetCreateOptions_ImFf				2
#define		kSetCreateOptions_ImFc				3
#define		kSetCreateOptions_ImEq				4
#define		kSetCreateOptions_ImHfov			5
#define		kSetCreateOptions_ImW				6
#define		kSetCreateOptions_ImH				7
#define		kSetCreateOptions_Correct			8
#define		kSetCreateOptions_PRe				9
#define		kSetCreateOptions_PPa				10
#define		kSetCreateOptions_PSp				11
#define		kSetCreateOptions_PCu				12
#define		kSetCreateOptions_PHfov				13
#define		kSetCreateOptions_PWi				14
#define		kSetCreateOptions_PHe				15
#define		kSetCreateOptions_PSave				16
#define		kSetCreateOptions_TY				17
#define		kSetCreateOptions_TP				18
#define		kSetCreateOptions_TR				19
#define		kSetCreateOptions_SLoad				20
#define		kSetCreateOptions_SPaste			21
#define		kSetCreateOptions_SBlend			22
#define		kSetCreateOptions_SF				23
#define		kSetCreateOptions_SIm				24
#define		kSetCreateOptions_SBuf				25
#define		kSetCreateOptions_Sboth				26
#define		kSetCreateOptions_Snone				27
#define		kSetCreateOptions_Pan				28
#define		kSetCreateOptions_dlg											\
	{																		\
	pt_help_connect(dlg, "adjExtract");										\
	MAKE_TABLE(2, 2);														\
																			\
	{																		\
		GtkWidget				*ftable;									\
		frame = gtk_frame_new(_("Image:"));									\
		gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);	\
			gtk_container_set_border_width(GTK_CONTAINER(frame), 2);		\
		gtk_table_attach(GTK_TABLE(table), frame, 0, 1, 0, 1,				\
			GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);							\
		gtk_widget_show (frame);											\
		ftable = gtk_table_new(4, 3, FALSE);								\
		gtk_container_set_border_width(GTK_CONTAINER(ftable), 2);			\
		gtk_container_add(GTK_CONTAINER(frame), ftable);					\
		gtk_widget_show(ftable);											\
		MAKE_BFRAME(ftable, _("Format:"), 2, 3, 0, 4, 5);					\
		MAKE_RADIO_BUTTON( kSetCreateOptions_ImR,  _("Rectilinear"))		\
		MAKE_RADIO_BUTTON( kSetCreateOptions_ImP,  _("Panoramic"))			\
		MAKE_RADIO_BUTTON( kSetCreateOptions_ImFf, _("Fisheye fullfr."))	\
		MAKE_RADIO_BUTTON( kSetCreateOptions_ImFc, _("Fisheye circ."))		\
		MAKE_RADIO_BUTTON( kSetCreateOptions_ImEq, _("Equirectangular."))	\
		MAKE_TEXTLABEL(_("HFoV:"),	 ftable, 0, 1, 0, 1);					\
		MAKE_TEXTLABEL(_("Width:"),	 ftable, 0, 1, 1, 2);					\
		MAKE_TEXTLABEL(_("Height:"), ftable, 0, 1, 2, 3);					\
		button = gtk_button_new_with_label (_("Correct"));					\
		INSERT_FBUTTON( 1, 2, 3, 4)											\
		g_signal_connect (GTK_OBJECT (button), "clicked",					\
							 (GtkSignalFunc) SetCPrefs,						\
							 (gpointer) &localPrefs.im.cP);					\
		gtk_widget_show(button);											\
		MAKE_FTEXT_WID( kSetCreateOptions_ImHfov ,	1, 2, 0, 1 );			\
		MAKE_FTEXT_WID( kSetCreateOptions_ImW ,		1, 2, 1, 2 );			\
		MAKE_FTEXT_WID( kSetCreateOptions_ImH ,		1, 2, 2, 3 );			\
	}																		\
	{																		\
		GtkWidget				*ftable;									\
		frame = gtk_frame_new(_("Panorama:"));								\
		gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);	\
			gtk_container_set_border_width(GTK_CONTAINER(frame), 2);		\
		gtk_table_attach(GTK_TABLE(table), frame, 0, 1, 1, 2,				\
			GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);							\
		gtk_widget_show (frame);											\
		ftable = gtk_table_new(4, 3, FALSE);								\
		gtk_container_set_border_width(GTK_CONTAINER(ftable), 2);			\
		gtk_container_add(GTK_CONTAINER(frame), ftable);					\
		gtk_widget_show(ftable);											\
		MAKE_BFRAME(ftable, _("Format:"), 2, 3, 0, 3, 3);					\
		MAKE_RADIO_BUTTON( kSetCreateOptions_PRe, _("Rectilinear"))			\
		MAKE_RADIO_BUTTON( kSetCreateOptions_PPa, _("QTVR-Panorama"))		\
		MAKE_RADIO_BUTTON( kSetCreateOptions_PSp, _("PSphere"))				\
		MAKE_FCHECK_BOX(kSetCreateOptions_PSave, _("Save to Buffer"), 0, 2, 3, 4 ) \
		MAKE_TEXTLABEL(_("HFoV:"),	 ftable, 0, 1, 0, 1);					\
		MAKE_TEXTLABEL(_("Width:"),	 ftable, 0, 1, 1, 2);					\
		MAKE_TEXTLABEL(_("Height:"), ftable, 0, 1, 2, 3);					\
		MAKE_FTEXT_WID( kSetCreateOptions_PHfov , 1, 2, 0, 1 );				\
		MAKE_FTEXT_WID( kSetCreateOptions_PWi ,	  1, 2, 1, 2 );				\
		MAKE_FTEXT_WID( kSetCreateOptions_PHe ,	  1, 2, 2, 3 );				\
	}																		\
	{																		\
		GtkWidget				*ftable;									\
		frame = gtk_frame_new(_("Position:"));								\
		gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);	\
			gtk_container_set_border_width(GTK_CONTAINER(frame), 2);		\
		gtk_table_attach(GTK_TABLE(table), frame, 1, 2, 0, 1,				\
			GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);							\
		gtk_widget_show (frame);											\
		ftable = gtk_table_new(3, 2, FALSE);								\
		gtk_container_set_border_width(GTK_CONTAINER(ftable), 2);			\
		gtk_container_add(GTK_CONTAINER(frame), ftable);					\
		gtk_widget_show(ftable);											\
		MAKE_TEXTLABEL(_("Yaw: -180...+180"), ftable, 0, 1, 0, 1);			\
		MAKE_TEXTLABEL(_("Pitch: -90...+90"), ftable, 0, 1, 1, 2);			\
		MAKE_TEXTLABEL(_("Roll:"),			  ftable, 0, 1, 2, 3);			\
		MAKE_FTEXT_WID( kSetCreateOptions_TY , 1, 2, 0, 1 );				\
		MAKE_FTEXT_WID( kSetCreateOptions_TP , 1, 2, 1, 2 );				\
		MAKE_FTEXT_WID( kSetCreateOptions_TR , 1, 2, 2, 3 );				\
	}																		\
	{																		\
		GtkWidget				*ftable;									\
		frame = gtk_frame_new(_("Stitching:"));								\
		gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);	\
			gtk_container_set_border_width(GTK_CONTAINER(frame), 2);		\
		gtk_table_attach(GTK_TABLE(table), frame, 1, 2, 1, 2,				\
			GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);							\
		gtk_widget_show (frame);											\
		ftable = gtk_table_new(4, 4, FALSE);								\
		gtk_container_set_border_width(GTK_CONTAINER(ftable), 2);			\
		gtk_container_add(GTK_CONTAINER(frame), ftable);					\
		gtk_widget_show(ftable);											\
		MAKE_FCHECK_BOX(kSetCreateOptions_SLoad, _("Load Buffer and "), 0, 2, 0, 1 ) \
		box = gtk_vbox_new(FALSE, 2);										\
		gtk_container_set_border_width(GTK_CONTAINER(box), 2);				\
		gtk_table_attach(GTK_TABLE(ftable), box, 0, 2, 1, 3,				\
			GTK_FILL | GTK_EXPAND, GTK_FILL, 5, 0);							\
		gtk_widget_show (box);												\
		group = NULL;														\
		MAKE_RADIO_BUTTON(kSetCreateOptions_SBlend,	 _("blend or"))			\
		MAKE_RADIO_BUTTON(kSetCreateOptions_SPaste,	 _("paste"))			\
		MAKE_TEXTLABEL(_("Feather:"),		ftable, 0, 1, 3, 4);			\
		MAKE_FTEXT_WID( kSetCreateOptions_SF ,		1, 2, 3, 4 );			\
		MAKE_BFRAME(ftable, _("Color Adjustment:"), 2, 4, 0, 4, 4);			\
		MAKE_RADIO_BUTTON(kSetCreateOptions_SIm,   _("Image"))				\
		MAKE_RADIO_BUTTON(kSetCreateOptions_SBuf,  _("Buffer"))				\
		MAKE_RADIO_BUTTON(kSetCreateOptions_Sboth, _("Both"))				\
		MAKE_RADIO_BUTTON(kSetCreateOptions_Snone, _("None"))				\
	}																		\
	}

//-------------------- Interpolator Selection ------------------------------

#define kPoly			0
#define kSp16			1
#define kSp36			2
#define kSinc256		3
#define kSinc1024		4
#define kSetIntp_Gamma	5
#define kIntrpNorm		6
#define kIntrpMed		7
#define kIntrpFast		8
#define kSetIntp													\
	pt_help_connect(dlg, "useSelInterp");							\
	MAKE_TABLE(3, 6);												\
																	\
	MAKE_TEXTLABEL(_("<- Faster"),		table, 2, 3, 1, 2);			\
	MAKE_TEXTLABEL(_("Better ->"),		table, 2, 3, 2, 3);			\
																	\
	MAKE_BFRAME(table, _("Use Algorithm:"), 0, 2, 0, 4, 5);			\
	MAKE_RADIO_BUTTON( kPoly,	  _("Polynomial 16 pixels"))		\
	MAKE_RADIO_BUTTON( kSp16,	  _("Spline		16 pixels"))		\
	MAKE_RADIO_BUTTON( kSp36,	  _("Spline		36 pixels"))		\
	MAKE_RADIO_BUTTON( kSinc256,  _("Sinc		256 pixels"))		\
	MAKE_RADIO_BUTTON( kSinc1024, _("Sinc		1024 pixels"))		\
																	\
	MAKE_BFRAME(table, _("Interpolation speed:"), 0, 2, 4, 5, 3);	\
	MAKE_RADIO_BUTTON( kIntrpNorm, _("Normal") )					\
	MAKE_RADIO_BUTTON( kIntrpMed,  _("Medium") )					\
	MAKE_RADIO_BUTTON( kIntrpFast, _("Fast") )						\
																	\
	MAKE_TEXTLABEL(_("Gamma:"),		  table, 0, 1, 5, 6);			\
	MAKE_TEXT_WID( kSetIntp_Gamma ,		1, 2, 5, 6 );


#define kSetSizePrefs_Crop				0
#define kSetSizePrefs_SFile				1
#define kSetSizePrefs_SetInt			2
#define kSetSizePrefs_dlg														\
	pt_help_connect(dlg, "useSetPrefs");										\
	MAKE_TABLE(2, 2);															\
																				\
	MAKE_BFRAME(table, _("If source and result size differ:"), 0, 1, 0, 2, 2);	\
	MAKE_RADIO_BUTTON( kSetSizePrefs_Crop, _("Display cropped/framed image"))	\
	MAKE_RADIO_BUTTON( kSetSizePrefs_SFile, _("Resize image"))					\
																				\
	button = gtk_button_new_with_label (_("More"));								\
	INSERT_BUTTON( 1, 2, 0, 1)													\
	g_signal_connect (GTK_OBJECT (button), "clicked",							\
					  (GtkSignalFunc) SetIntp,									\
					  (gpointer) &localPrefs);									\
	gtk_widget_show(button);


#define		kSetFourierOptions_PSDname			0
#define		kSetFourierOptions_findPSD			1
#define		kSetFourierOptions_addBlur			2
#define		kSetFourierOptions_remBlur			3
#define		kSetFourierOptions_internal			4
#define		kSetFourierOptions_custom			5
#define		kSetFourierOptions_findNFF			6
#define		kSetFourierOptions_filterfactor		7
#define		kSetFourierOptions_fourier_frame	8
#define		kSetFourierOptions_dlg												\
		pt_help_connect(dlg, "corFourier");										\
		MAKE_TABLE(4,7);														\
		MAKE_TEXTLABEL(_("Point spread image:"), table, 0, 2, 0, 1);			\
		button = gtk_button_new_with_label (_("Browse"));						\
		INSERT_BUTTON( 3, 4, 0, 1)												\
		g_signal_connect (GTK_OBJECT (button), "clicked",						\
							 (GtkSignalFunc) pt_find_file,						\
							 (gpointer) &(localPrefs.psf) );					\
		gtk_widget_show(button);												\
																				\
		MAKE_TEXTLABEL(_("Mode:"), table, 0, 1, 2, 3);							\
		box = gtk_vbox_new(FALSE, 2);											\
		gtk_container_set_border_width(GTK_CONTAINER(box), 5);					\
		gtk_table_attach(GTK_TABLE(table), box, 1, 3, 2, 4,						\
			GTK_FILL | GTK_EXPAND, GTK_FILL, 5, 0);								\
		gtk_widget_show (box);													\
		group = NULL;															\
		MAKE_RADIO_BUTTON( kSetFourierOptions_addBlur, _("Add blur"))			\
		MAKE_RADIO_BUTTON( kSetFourierOptions_remBlur, _("Remove blur"))		\
		MAKE_TEXTLABEL(_("Noise reduction"), table, 0, 1, 4, 5);				\
		box = gtk_vbox_new(FALSE, 2);											\
		gtk_container_set_border_width(GTK_CONTAINER(box), 5);					\
		gtk_table_attach(GTK_TABLE(table), box, 1, 3, 4, 6,						\
			GTK_FILL | GTK_EXPAND, GTK_FILL, 5, 0);								\
		gtk_widget_show (box);													\
		group = NULL;															\
		MAKE_RADIO_BUTTON( kSetFourierOptions_internal,	   _("Internal"))		\
		MAKE_RADIO_BUTTON( kSetFourierOptions_custom,	 _("External"))			\
		button = gtk_button_new_with_label (_("Browse"));						\
		INSERT_BUTTON( 3, 4, 5, 6)												\
		g_signal_connect (GTK_OBJECT (button), "clicked",						\
							 (GtkSignalFunc) pt_find_file,						\
							 (gpointer) &(localPrefs.nff) );					\
		gtk_widget_show(button);												\
		MAKE_TEXTLABEL(_("Filter factor:"), table, 0, 1, 6, 7);					\
		MAKE_TEXT_WID( kSetFourierOptions_filterfactor , 1, 2, 6, 7 );			\
		MAKE_TEXTLABEL(_("Frame"), table, 2, 3, 6, 7);							\
		MAKE_TEXT_WID( kSetFourierOptions_fourier_frame , 3, 4, 6, 7 );


#endif
